commit:     866e92f37655f0ac9c06189e5135809376a137c7
Author:     Michał Górny <mgorny <AT> gentoo <DOT> org>
AuthorDate: Sun Feb  7 17:57:38 2016 +0000
Commit:     Michał Górny <mgorny <AT> gentoo <DOT> org>
CommitDate: Sun Feb  7 18:50:55 2016 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=866e92f3

dev-lang/python-exec: Major version bump to 2.3

The new 2.3 release is the first release using new python-exec.conf
configuration file that allows users to specify complete Python
implementation preferences for python-exec.

 dev-lang/python-exec/Manifest               |   1 +
 dev-lang/python-exec/python-exec-2.3.ebuild | 111 ++++++++++++++++++++++++++++
 2 files changed, 112 insertions(+)

diff --git a/dev-lang/python-exec/Manifest b/dev-lang/python-exec/Manifest
index a7e78f9..51dfade 100644
--- a/dev-lang/python-exec/Manifest
+++ b/dev-lang/python-exec/Manifest
@@ -3,3 +3,4 @@ DIST python-exec-2.0.2.tar.bz2 82217 SHA256 
c411638fe94953c1e8ff57e7b66f601a8176
 DIST python-exec-2.1.tar.bz2 82167 SHA256 
adac4e9ae677ca0fbb9efc55573ecbb0e8361ed7a60a5241e7abc1056fba06ad SHA512 
cadfb7723aa412caec4a449909769b14a800c19650c64768b0ffb30b2c0645e70c9a039f960f3263c6c18490bb73c0129b83a72c7407f558bcaf3652cc4c8bcf
 WHIRLPOOL 
72b73b216faf7caa8afbc3ce316771bd832e468cf84835267dc3833d5c52fce24578e09f2d3aa8a322f324426eda5e53bd9611711ea976679574b2be764c2525
 DIST python-exec-2.2.1.tar.bz2 82990 SHA256 
c0fcb0c9593b26cf56cdf39ff265586a2203d608f6bfafecde0ff756de019f04 SHA512 
3ca01ce229e4ecdf09a55f6bad0c90c1f0a9cff1fecb0013bb2ada1e187044631ad01af0fa70fb805465dd4e6c953cc97203d91f55ccb5208f63bf4771c0bb20
 WHIRLPOOL 
92e9c4629f292a0f517927e05aceda68f0c797426070ec23139dedeb1eac4d2a315892fd231ee0fe019dd3e9c6bd148fad9764ad65617012b1ef0bfbe0415506
 DIST python-exec-2.2.tar.bz2 82269 SHA256 
041dccf96c31bfac5eee9c43bdf511821449313a5b7d0bd745bed09151e1bffe SHA512 
9492d94e7134b555a2f3b81cbd4e159074fed21b1471090547618da34dab70264a3fa40c8b7f79c42b61938655006dd5659e26389649a2401c26b4e0c90c9ac1
 WHIRLPOOL 
0b13d73c2e3c9606589201af34504c317965c29bb5cfe211479d893c606ca05dff62755fcba5f76d0a653a2719f36119e6f3db050ffa9f9bb01ef2ff7b68cb4d
+DIST python-exec-2.3.tar.bz2 84201 SHA256 
04f7c92727f666e4f950157a39ed6ac0a48d1a746736cc515a97195a30a3f9fe SHA512 
fc6b8702a7009873b42dcde4b1771913f43ab45d92c62b9856a903b48dbe32c4ab588abe239e4512d9e2026a24aff26ec572f5cd98613e6a0160dcbd642e0849
 WHIRLPOOL 
3c5c238dbbf174dbbede06109bfc32e9675f53ded011dffdc0ce9327adff778bec6d89aba18ea531548d3e1ed17808f1a29cc1085f620baada74d71695f56b41

diff --git a/dev-lang/python-exec/python-exec-2.3.ebuild 
b/dev-lang/python-exec/python-exec-2.3.ebuild
new file mode 100644
index 0000000..cbf297e
--- /dev/null
+++ b/dev-lang/python-exec/python-exec-2.3.ebuild
@@ -0,0 +1,111 @@
+# Copyright 1999-2016 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Id$
+
+EAPI=5
+
+# Kids, don't do this at home!
+inherit python-utils-r1
+PYTHON_COMPAT=( "${_PYTHON_ALL_IMPLS[@]}" )
+
+# Inherited purely to have PYTHON_TARGET flags which will satisfy USE
+# dependencies and trigger necessary rebuilds.
+inherit python-r1
+
+DESCRIPTION="Python script wrapper"
+HOMEPAGE="https://bitbucket.org/mgorny/python-exec/";
+SRC_URI="https://www.bitbucket.org/mgorny/${PN}/downloads/${P}.tar.bz2";
+
+LICENSE="BSD-2"
+SLOT="2"
+KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~m68k ~mips ~ppc ~ppc64 ~s390 
~sh ~sparc ~x86 ~ppc-aix ~amd64-fbsd ~x86-fbsd ~x64-freebsd ~x86-freebsd 
~amd64-linux ~arm-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~m68k-mint 
~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+IUSE=""
+
+# eselect-python because of /usr/bin/python* collisions and new config
+# python versions because of missing $scriptdir/python* symlinks
+RDEPEND="
+       !<app-eselect/eselect-python-20160206
+       !<dev-lang/python-2.7.10-r4:2.7
+       !<dev-lang/python-3.3.5-r4:3.3
+       !<dev-lang/python-3.4.3-r4:3.4
+       !<dev-lang/python-3.5.0-r3:3.5"
+
+src_configure() {
+       local pyimpls=() i EPYTHON
+       for i in "${PYTHON_COMPAT[@]}"; do
+               python_export "${i}" EPYTHON
+               pyimpls+=( "${EPYTHON}" )
+       done
+
+       local myconf=(
+               --with-python-impls="${pyimpls[*]}"
+       )
+
+       econf "${myconf[@]}"
+}
+
+src_install() {
+       default
+
+       # Prepare and own the template
+       sed -n -e '/^#/p' config/python-exec.conf.example \
+               > "${T}"/python-exec.conf || die
+       insinto /etc/python-exec
+       doins "${T}"/python-exec.conf
+
+       local f
+       for f in python{,2,3}; do
+               # can't use symlinks here since random stuff
+               # loves to do readlink on sys.executable...
+               newbin python-exec2-c "${f}"
+       done
+       for f in python{,2,3}-config 2to3 idle pydoc pyvenv; do
+               dosym ../lib/python-exec/python-exec2 /usr/bin/"${f}"
+       done
+}
+
+pkg_preinst() {
+       if [[ -e ${EROOT}etc/python-exec/python-exec.conf ]]; then
+               # preserve current configuration
+               cp "${EROOT}"etc/python-exec/python-exec.conf \
+                       "${ED}"etc/python-exec/python-exec.conf || die
+       else
+               # preserve previous Python version preference
+               local py old_pythons=()
+               local config_base=${EROOT}etc/env.d/python
+
+               # start with the 'global' preference (2 vs 3)
+               if [[ -f ${config_base}/config ]]; then
+                       old_pythons+=( "$(<${config_base}/config)" )
+               fi
+
+               # then try specific py3 selection
+               for py in 3; do
+                       local target=
+
+                       if [[ -f ${config_base}/python${py} ]]; then
+                               # try the newer config files
+                               target=$(<${config_base}/python${py})
+                       elif [[ -L ${EROOT}/usr/bin/python${py} ]]; then
+                               # check the older symlink format
+                               target=$(readlink 
"${EROOT}/usr/bin/python${py}")
+
+                               # check if it's actually old eselect symlink
+                               [[ ${target} == python?.? ]] || target=
+                       fi
+
+                       # add the extra target if found and != global
+                       if [[ ${target} && ${old_pythons[0]} != ${target} ]]; 
then
+                               old_pythons+=( "${target}" )
+                       fi
+               done
+
+               if [[ ${old_pythons[@]} ]]; then
+                       einfo "Keeping the following Python preference: 
${old_pythons[*]}"
+
+                       local IFS=$'\n'
+                       echo "${old_pythons[*]}" \
+                               >> "${ED}"etc/python-exec/python-exec.conf || 
die
+               fi
+       fi
+}

Reply via email to